#include <string.h>
#include <stdio.h>
#include <stdlib.h>

/* strcmp: return <0 if s<t, 0 if s==t, >0 if s>t */
int mystrcmp(char *s, char *t)
{
 int i;
 for (i = 0; s[i] == t[i]; i++)
  if (s[i] == '\0')
   return 0;
 return s[i] - t[i];
}

/* The pointer version of strcmp :
 strcmp: return <0 if s<t, 0 if s==t, >0 if s>t */
int mystrcmpptr(char *s, char *t)
{
 for ( ; *s == *t; s++, t++){
  if (*s == '\0')
   return 0;
 }
 return *s - *t;
}

int main(int argc, char* argv[]) {
  int len1,len2;
  char *cad1,*cad2,*tmp;
  if( argc < 3){
    printf("\t uso: compcads cadena1 cadena2 \n");
    return(1);
  }
  len1 = strlen(argv[1]+1); /*largo cadena 1*/
  cad1 = (char *)malloc(len1*sizeof(char));
  strcpy(cad1,argv[1]);

  len2 = strlen(argv[2]+1); /*largo cadena 2*/
  cad2 = (char *)malloc(len2*sizeof(char));
  strcpy(cad2,argv[2]);
  printf("cad1: %s \ncad2: %s \n",cad1,cad2);
  
  tmp = (char *)malloc((len1+len2)*sizeof(char));
  strcpy(tmp, cad1);
  printf("tmp %s \n",tmp);
  if(mystrcmp(tmp,cad2)==0)
    printf("tmp y cad2 son iguales\n");
  else
    printf("tmp y cad2 NO son iguales\n");
  if(mystrcmp(tmp,cad1)==0)
    printf("tmp y cad1 son iguales\n");
  else
    printf("tmp y cad1 NO son iguales\n");

  if(mystrcmpptr(tmp,cad2)==0)
    printf("tmp y cad2 son iguales\n");
  else
    printf("tmp y cad2 NO son iguales\n");

  printf("tmp y cad1 %s", mystrcmpptr(tmp,cad1)==0 ? "son" : "no son");
  printf(" iguales\n");

  return(0);
}
